'use strict';

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reduxShip = require('redux-ship');

var Ship = _interopRequireWildcard(_reduxShip);

var _view = require('./view');

var _view2 = _interopRequireDefault(_view);

var _store = require('./store');

var _store2 = _interopRequireDefault(_store);

var _controller = require('./controller');

var Controller = _interopRequireWildcard(_controller);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function dispatch(action) {
  Ship.run(function () {}, _store2.default, Controller.control(action));
}


function render() {
  _reactDom2.default.render(_react2.default.createElement(_view2.default, {
    dispatch: dispatch,
    state: _store2.default.getState()
  }), document.getElementById('root'));
}

_store2.default.subscribe(render);

var eventPageConnection = window.chrome.runtime.connect({
  name: 'ReduxShipDevtools'
});

eventPageConnection.postMessage({
  name: 'init',
  tabId: window.chrome.devtools.inspectedWindow.tabId
});

eventPageConnection.onMessage.addListener(function (message) {
  dispatch({
    type: 'AddLog',
    action: message.action,
    snapshot: message.snapshot
  });
});

render();